from .models import Hardware, HardwareApproval
from .serializers import HardwareSerializer, HardwareApprovalSerializer
from rest_framework import generics
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework.parsers import JSONParser
from datetime import datetime


class HardwareCreateRead(generics.ListCreateAPIView):
    queryset = Hardware.objects.all().order_by('id').reverse()
    serializer_class = HardwareSerializer

    def perform_create(self, serializer):
        print("Device PID: "+ self.request.data["device_pid"])
        print("End of Support: "+ self.request.data["end_of_support"])
        print("Technology: "+ self.request.data["technology"])
        print("Date Generated: "+ self.request.data["date_generated"])
        print("Generated by: "+ self.request.data["generated_by"])
        queryset = Hardware.objects.filter(
            device_pid=self.request.data["device_pid"])
        if queryset.exists():
            raise ValidationError('Duplicate Detected !!!')
        serializer.save()


class HardwareUpdateDelete(generics.RetrieveUpdateDestroyAPIView):
    queryset = Hardware.objects.all()
    serializer_class = HardwareSerializer


@api_view(['POST'])
def hardware_insert_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataHardware"]
    for data in request_data:
        serializer = HardwareSerializer(data=data)
        if serializer.is_valid():
            serializer.save()
    return Response(request_data)


@api_view(['POST'])
def hardware_update_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataHardware"]
    for data in request_data:
        hardware = Hardware.objects.filter(
            id=data["approval_id"]).update(device_pid=data["device_pid"],
                                           end_of_support=data["end_of_support"],
                                           technology=data["technology"],
                                           date_generated=["date_generated"],
                                           generated_by=data["generated_by"])

    return Response(request_data)


@api_view(['POST'])
def hardware_delete_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataHardware"]
    for data in request_data:
        hardware = Hardware.objects.get(id=data["id"])
        hardware.delete()
    # print(request_data)
    return Response(request_data)


class HardwareApprovalCreateRead(generics.ListCreateAPIView):
    querysetOri = Hardware.objects.all().order_by('id').reverse()
    queryset = HardwareApproval.objects.all().order_by('id').reverse()
    serializer_class = HardwareApprovalSerializer

    def perform_create(self, serializer):
        # print(self.request.data["device_pid"])
        querysetOri = Hardware.objects.filter(
            device_pid=self.request.data["device_pid"])
        if querysetOri.exists():
            raise ValidationError('Duplicate Detected !!!')
            
        # print(self.request.data["device_pid"])
        queryset = HardwareApproval.objects.filter(
            device_pid=self.request.data["device_pid"])
        if queryset.exists():
            raise ValidationError('Duplicate Detected !!!')

        serializer.save()


@api_view(['POST'])
def hardware_approval_member(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["username"]
    queryset = HardwareApproval.objects.all().filter(generated_by=request_data)
    serializer_class = HardwareApprovalSerializer(queryset, many=True)
    return Response(serializer_class.data)


class HardwareApprovalUpdateDelete(generics.RetrieveUpdateDestroyAPIView):
    queryset = HardwareApproval.objects.all()
    serializer_class = HardwareApprovalSerializer


@api_view(['POST'])
def hardware_approval_delete_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataHardware"]
    for data in request_data:
        hardwareapproval = HardwareApproval.objects.get(id=data["id"])
        hardwareapproval.delete()
    # print(request_data)
    return Response(request_data)
